package es.prodevelop.tilecache.renderer;

import es.prodevelop.gvsig.mini.geom.Extent;
import es.prodevelop.gvsig.mini.geom.Point;
import es.prodevelop.gvsig.mini.map.GeoUtils;

public class OSMZYXRenderer extends OSMMercatorRenderer {

	OSMZYXRenderer(String[] baseUrl, String name, String imageFilenameEnding,
			int zoomMax, int zoomMin, int tileSizePX, int type, Point origin,
			Extent maxExtent, String SRS, double[] resolutions, Extent offExtent) {
		super(baseUrl, name, imageFilenameEnding, zoomMax, zoomMin, tileSizePX, type,
				origin, maxExtent, SRS, resolutions, offExtent);
		// TODO Auto-generated constructor stub
	}
	
	/**
	 * Instantiates a new OSMMercatorRenderer
	 * 
	 * @param aBaseUrl
	 *            The base URL of a OSM layer
	 * @param aName
	 *            The name of the layer
	 * @param aImageFilenameEnding
	 *            The format of the tile (png, jpg, jpeg, etc.)
	 * @param aZoomMax
	 *            The max zoom level
	 * @param aZoomMin
	 *            The min zoom level
	 * @param aTileSizePX
	 *            The tile size in pixels (Usually 256)
	 * @param type
	 *            0
	 * @param origin
	 *            The origin of the maxExtent, can be de left bottom corner, or
	 *            the left upper corner of the extent
	 * @param maxExtent
	 *            The max boundary box of the layer
	 * @param SRS
	 *            The SRS code
	 * @param resolutions
	 *            pixel resolution of each zoom level
	 * @return
	 */
	public static OSMZYXRenderer getOSMZYXRenderer(
			final String[] aBaseUrl, final String aName,
			final String aImageFilenameEnding, final int aZoomMax,
			final int aZoomMin, final int aTileSizePX, final int type,
			final Point origin, final Extent maxExtent, final String SRS,
			final double[] resolutions, Extent offExtent) {

		OSMZYXRenderer r = new OSMZYXRenderer(aBaseUrl, aName,
				aImageFilenameEnding, aZoomMax, aZoomMin, aTileSizePX, type,
				origin, maxExtent, SRS, resolutions, offExtent);
		return r;
	}
	
	@Override
	public String getTileURLString(final int[] tileID, final int zoomLevel) {
		return new StringBuilder().append(this.getBASEURL()).append(zoomLevel)
				.append("/").append(tileID[GeoUtils.MAPTILE_LATITUDE_INDEX])
				.append("/").append(tileID[GeoUtils.MAPTILE_LONGITUDE_INDEX])
				.append(".").append(this.getIMAGE_FILENAMEENDING()).toString();
	}

}
